;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-intermediate-lambda-reader.ss" "lang")((modname mark-depth) (read-case-sensitive #t) (teachpacks ()) (htdp-settings #(#t constructor repeating-decimal #f #t none #f ())))
;; bintree-depth

(require rackunit)
(require "extras.rkt")

(define-struct bintree (left data right))

;; A BinTree<X> is either
;; -- empty
;; -- (make-bintree BinTree<X> X BinTree<X>)

;; Template:
;; bintree-fn : BinTree<?> -> ??
;; (define (bintree-fn tree)
;;   (cond
;;     [(empty? tree) ...]
;;     [else (... 
;;            (bintree-fn (bintree-left tree))
;;            (bintree-data tree)
;;            (bintree-fn (bintree-right tree)))]))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; Version 1: Using Generalization

;; mark-depth-from : Bintree<X> Number -> Bintree<Number>
;; RETURNS: a bintree like the given one, except that each node is
;; replaced by its depth STARTING FROM d
;; EXAMPLES: see below
;; STRATEGY: structural decomposition on Bintree<X> [tree] 

(define (mark-depth-from tree d) 
   (cond
     [(empty? tree) empty]
     [else (make-bintree
            (mark-depth-from (bintree-left tree) (+ d 1))
            d
            (mark-depth-from (bintree-right tree) (+ d 1)))]))


;; mark-depth : Bintree<X> -> Bintree<Number>
;; RETURNS: a bintree like the given one, except that each node is
;; replaced by its depth.
;; EXAMPLES: see below
;; STRATEGY: functional composition

(define (mark-depth tree)
  (mark-depth-from tree 0))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; Version 2: Using an invariant

;; GIVEN: a subtree tree of tree0
;; WHERE: tree is a subtree of tree0 at depth d
;; RETURNS: a subtree like the given one, but with each node
;; containing its depth in tree0
;; STRATEGY: Struct Decomp on tree : BinTree<X>

;; the code is exactly the same, but the purpose statement is different!

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; tests

(begin-for-test
  (check-equal?
    (mark-depth
      (make-bintree 
        (make-bintree
          (make-bintree empty "foo" empty)
          "bar"
          empty)
        "baz"
        (make-bintree
          (make-bintree empty "quux" empty)
          "frob"
          empty)))

    (make-bintree 
      (make-bintree
        (make-bintree empty 2 empty)
        1
        empty)
      0
      (make-bintree
        (make-bintree empty 2 empty)
        1
        empty)))

  (check-equal?
    (mark-depth-from 
      (make-bintree 
        (make-bintree
          (make-bintree empty "foo" empty)
          "bar"
          empty)
        "baz"
        (make-bintree
          (make-bintree empty "quux" empty)
          "frob"
          empty))
      10)

    (make-bintree 
      (make-bintree
        (make-bintree empty 12 empty)
        11
        empty)
      10
      (make-bintree
        (make-bintree empty 12 empty)
        11
        empty))))
